"""
Devopness API Python SDK - Painless essential DevOps to everyone

Note:
    This is auto generated by OpenAPI Generator.
    https://openapi-generator.tech
"""

from typing import List, Optional

from .. import DevopnessBaseService, DevopnessBaseServiceAsync, DevopnessResponse
from ..models import EnvironmentRelation
from ..utils import parse_query_string


class OrganizationsEnvironmentsApiService(DevopnessBaseService):
    """
    OrganizationsEnvironmentsApiService - Auto Generated
    """

    def list_organization_environments(
        self,
        organization_id: str,
        page: Optional[int] = None,
        per_page: Optional[int] = None,
    ) -> DevopnessResponse[List[EnvironmentRelation]]:
        """
        Return a list of all environments owned by an organization

        Raises:
            DevopnessApiError: If an API request error occurs.
            DevopnessNetworkError: If a network error occurs.
        """

        query_string = parse_query_string(
            {
                "page": page,
                "per_page": per_page,
            }
        )

        endpoint_parts = [
            f"/organizations/{organization_id}/environments",
            f"?{query_string}",
        ]

        endpoint: str = "".join(endpoint_parts)

        response = self._get(endpoint)

        return DevopnessResponse(response, List[EnvironmentRelation])


class OrganizationsEnvironmentsApiServiceAsync(DevopnessBaseServiceAsync):
    """
    OrganizationsEnvironmentsApiServiceAsync - Auto Generated
    """

    async def list_organization_environments(
        self,
        organization_id: str,
        page: Optional[int] = None,
        per_page: Optional[int] = None,
    ) -> DevopnessResponse[List[EnvironmentRelation]]:
        """
        Return a list of all environments owned by an organization

        Raises:
            DevopnessApiError: If an API request error occurs.
            DevopnessNetworkError: If a network error occurs.
        """

        query_string = parse_query_string(
            {
                "page": page,
                "per_page": per_page,
            }
        )

        endpoint_parts = [
            f"/organizations/{organization_id}/environments",
            f"?{query_string}",
        ]

        endpoint: str = "".join(endpoint_parts)

        response = await self._get(endpoint)

        return DevopnessResponse(response, List[EnvironmentRelation])
