"""
Devopness API Python SDK - Painless essential DevOps to everyone

Note:
    This is auto generated by OpenAPI Generator.
    https://openapi-generator.tech
"""

from typing import (
    Optional,
    TypedDict,
)

from pydantic import Field, StrictBool, StrictStr

from .. import DevopnessBaseModel


class OperationCustomSettings(DevopnessBaseModel):
    """
    OperationCustomSettings

    Attributes:
        operation (str, optional): The resource&#39;s custom operation that are CSP specific
        operation_human_readable (str, optional): Human redable version of the resource&#39;s custom operation
        triggers_action (bool, optional): Whether the &#x60;server:remove&#x60; operation will trigger an action or not
    """

    operation: Optional[StrictStr] = Field(
        default=None,
        description="The resource's custom operation that are CSP specific",
    )
    operation_human_readable: Optional[StrictStr] = Field(
        default=None,
        description="Human redable version of the resource's custom operation",
    )
    triggers_action: Optional[StrictBool] = Field(
        default=None,
        description="Whether the `server:remove` operation will trigger an action or not",
    )


class OperationCustomSettingsPlain(TypedDict, total=False):
    """
    Plain version of OperationCustomSettings.
    """

    operation: Optional[str]
    operation_human_readable: Optional[str]
    triggers_action: Optional[bool]
