"""
Devopness API Python SDK - Painless essential DevOps to everyone

Note:
    This is auto generated by OpenAPI Generator.
    https://openapi-generator.tech
"""

from typing import (
    Optional,
    Required,
    TypedDict,
)

from pydantic import Field, StrictStr

from .. import DevopnessBaseModel


class SubnetProvisionInputSettingsAws(DevopnessBaseModel):
    """
    SubnetProvisionInputSettingsAws

    Attributes:
        region (str, optional): The cloud provider region where the subnet will be created
        region_human_readable (str, optional): Human readable version of the subnet region
        zone (str): The cloud provider availability zone where the subnet will be created
        cidr_block (str): The IP CIDR range of the subnet
    """

    region: Optional[StrictStr] = Field(
        default=None,
        description="The cloud provider region where the subnet will be created",
    )
    region_human_readable: Optional[StrictStr] = Field(
        default=None, description="Human readable version of the subnet region"
    )
    zone: StrictStr = Field(
        description="The cloud provider availability zone where the subnet will be created"
    )
    cidr_block: StrictStr = Field(description="The IP CIDR range of the subnet")


class SubnetProvisionInputSettingsAwsPlain(TypedDict, total=False):
    """
    Plain version of SubnetProvisionInputSettingsAws.
    """

    region: Optional[str]
    region_human_readable: Optional[str]
    zone: Required[str]
    cidr_block: Required[str]
