"""
Devopness API Python SDK - Painless essential DevOps to everyone

Note:
    This is auto generated by OpenAPI Generator.
    https://openapi-generator.tech
"""

from typing import (
    Optional,
    Required,
    TypedDict,
)

from pydantic import Field, StrictInt, StrictStr

from .. import DevopnessBaseModel


class TeamUpdate(DevopnessBaseModel):
    """
    TeamUpdate

    Attributes:
        id (int): The unique ID of the given Team.
        name (str): The name of the team. Must not be greater than 255 characters.
        photo_url (str, optional): The URL to team&#39;s image. Must be a valid URL.
    """

    id: StrictInt = Field(description="The unique ID of the given Team.")
    name: StrictStr = Field(
        description="The name of the team. Must not be greater than 255 characters."
    )
    photo_url: Optional[StrictStr] = Field(
        default=None, description="The URL to team's image. Must be a valid URL."
    )


class TeamUpdatePlain(TypedDict, total=False):
    """
    Plain version of TeamUpdate.
    """

    id: Required[int]
    name: Required[str]
    photo_url: Optional[str]
